"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterDisabledNodes = filterDisabledNodes;
function filterDisabledNodes(graph) {
    const filteredGraph = graph.clone();
    for (const node of filteredGraph.getNodes().values()) {
        if (node.disabled) {
            filteredGraph.removeNode(node, {
                reconnectConnections: true,
                skipConnectionFn: (c) => c.type !== "main",
            });
        }
    }
    return filteredGraph;
}
//# sourceMappingURL=filterDisabledNodes.js.map