import type { CallbackManager, CloseFunction, ExecutionBaseError, IExecuteData, IExecuteFunctions, IExecuteResponsePromiseData, INode, INodeExecutionData, IRunExecutionData, ITaskDataConnections, ITaskMetadata, IWorkflowExecuteAdditionalData, NodeConnectionType, Workflow, WorkflowExecuteMode } from 'n8n-workflow';
import { BaseExecuteContext } from './base-execute-context';
export declare class ExecuteContext extends BaseExecuteContext implements IExecuteFunctions {
    private readonly closeFunctions;
    readonly helpers: IExecuteFunctions['helpers'];
    readonly nodeHelpers: IExecuteFunctions['nodeHelpers'];
    readonly getNodeParameter: IExecuteFunctions['getNodeParameter'];
    readonly startJob: IExecuteFunctions['startJob'];
    constructor(workflow: Workflow, node: INode, additionalData: IWorkflowExecuteAdditionalData, mode: WorkflowExecuteMode, runExecutionData: IRunExecutionData, runIndex: number, connectionInputData: INodeExecutionData[], inputData: ITaskDataConnections, executeData: IExecuteData, closeFunctions: CloseFunction[], abortSignal?: AbortSignal);
    getInputConnectionData(inputName: NodeConnectionType, itemIndex: number): Promise<unknown>;
    getInputData(inputIndex?: number, inputName?: string): INodeExecutionData[];
    putExecutionToWait(waitTill: Date): Promise<void>;
    logNodeOutput(...args: unknown[]): void;
    sendResponse(response: IExecuteResponsePromiseData): Promise<void>;
    addInputData(connectionType: NodeConnectionType, data: INodeExecutionData[][] | ExecutionBaseError): {
        index: number;
    };
    addOutputData(connectionType: NodeConnectionType, currentNodeRunIndex: number, data: INodeExecutionData[][] | ExecutionBaseError, metadata?: ITaskMetadata): void;
    getParentCallbackManager(): CallbackManager | undefined;
}
