import type { CloseFunction, IExecuteData, INode, INodeExecutionData, IRunExecutionData, ISupplyDataFunctions, ITaskDataConnections, ITaskMetadata, IWorkflowExecuteAdditionalData, NodeConnectionType, Workflow, WorkflowExecuteMode } from 'n8n-workflow';
import { BaseExecuteContext } from './base-execute-context';
export declare class SupplyDataContext extends BaseExecuteContext implements ISupplyDataFunctions {
    private readonly closeFunctions;
    readonly helpers: ISupplyDataFunctions['helpers'];
    readonly getNodeParameter: ISupplyDataFunctions['getNodeParameter'];
    constructor(workflow: Workflow, node: INode, additionalData: IWorkflowExecuteAdditionalData, mode: WorkflowExecuteMode, runExecutionData: IRunExecutionData, runIndex: number, connectionInputData: INodeExecutionData[], inputData: ITaskDataConnections, executeData: IExecuteData, closeFunctions: CloseFunction[], abortSignal?: AbortSignal);
    getInputConnectionData(inputName: NodeConnectionType, itemIndex: number): Promise<unknown>;
    getInputData(inputIndex?: number, inputName?: string): INodeExecutionData[];
    addInputData(connectionType: NodeConnectionType, data: INodeExecutionData[][]): {
        index: number;
    };
    addOutputData(connectionType: NodeConnectionType, currentNodeRunIndex: number, data: INodeExecutionData[][], metadata?: ITaskMetadata): void;
}
